package holmos.webtest.junitextentions.parameters.excel;

import holmos.webtest.log.MyLogger;

import java.util.ArrayList;

import org.apache.poi.ss.usermodel.Sheet;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class HolmosSheet {
	MyLogger logger = MyLogger.getLogger(HolmosSheet.class);
	private Sheet sheet;
	public HolmosSheet(Sheet sheet){
		this.sheet=sheet;
	}
	
	/**
	 * 取得此Sheet中有效的行数，有效是这么定义的，如果发现第一个空行，则达标此行无效
	 * */
	public int getValidRowCount(){
		return sheet.getLastRowNum()-sheet.getFirstRowNum()+1;
	}
	/**
	 * 获取所有的有效行
	 * */
	public ArrayList<HolmosRow>getValidRows(){
		ArrayList<HolmosRow>validRows=new ArrayList<HolmosRow>();
		for(int i=0;i<getValidRowCount();i++){
			validRows.add(new HolmosRow(sheet.getRow(i)));
		}return validRows;
	}
	
	/**
	 * 获取第index行，从0开始
	 * */
	public HolmosRow getRowByIndex(int index){
		if(index<getValidRowCount())
			return new HolmosRow(sheet.getRow(index));
		else{
			logger.error("要获取的数据行不存在!");
			return null;
		}
	}
	public void removeRowByIndex(int index){
		if(index<getValidRowCount()){
			sheet.removeRow(sheet.getRow(index));
		}else{
			logger.error("要删除的行在"+sheet.getSheetName()+"中不存在!");
		}
	}
}
