package holmos.webtest.junitextentions.parameters.getter;

import holmos.webtest.exceptions.HolmosFailedError;
import holmos.webtest.junitextentions.parameters.excel.HolmosWorkBook;

import java.util.ArrayList;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class ExcelDataGetter implements DataGetter{
	private HolmosWorkBook workBook;
	private int sheetIndex;
	public void setSheetIndex(int sheetIndex) {
		this.sheetIndex = sheetIndex;
	}
	public void setSheetName(String sheetName) {
		this.sheetName = sheetName;
	}
	private String sheetName;
	public ExcelDataGetter(String excelFilePath){
		this.sheetIndex=0;
		this.sheetName=null;
		workBook=new HolmosWorkBook(excelFilePath);
	}
	@Override
	public ArrayList<Object[]> getParameterByIDs(int[] ids) {
		ArrayList<Object[]> parameters=new ArrayList<Object[]>();
		for(int id:ids){
			parameters.addAll(getParameterByID(id));
		}
		return parameters;
	}

	@Override
	public ArrayList<Object[]> getAllParameter() {
		ArrayList<Object[]> parameters=new ArrayList<Object[]>();
		if(-1!=sheetIndex)
			for(ArrayList<Object>parameter:workBook.getValidValuesBySheetIndex(sheetIndex))
				parameters.add(parameter.toArray());
		else if(null!=sheetName){
			if(-1!=sheetIndex)
				for(ArrayList<Object>parameter:workBook.getValidValuesBySheetName(sheetName))
					parameters.add(parameter.toArray());
		}else
			throw new HolmosFailedError("请指定excel文件的索引号或者sheet的名字!");
		return parameters;
	}
	/**
	 * id的设置位置一定是第一列，否则框架不认
	 * */
	@Override
	public ArrayList<Object[]> getParameterByID(int id) {
		ArrayList<Object[]> result=new ArrayList<Object[]>();
		ArrayList<Object[]> parameters=getAllParameter();
		for(Object[] parameter:parameters){
			if(Integer.parseInt((String) parameter[0])==id){
				result.add(getActualParameter(parameter));
			}
		}
		return result;
	}
	private Object[]getActualParameter(Object[]parameter){
		Object[] acutalParameter=new Object[parameter.length-1];
		for(int i=1;i<parameter.length;i++)
			acutalParameter[i-1]=parameter[i];
		return acutalParameter;
	}
}
