package holmos.webtest.junitextentions.parameters.getter;

import holmos.webtest.constvalue.ConstValue;
import holmos.webtest.junitextentions.parameters.xml.HolmosXMLUtils;

import java.util.ArrayList;
import java.util.Iterator;

import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.Element;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class XMLDataGetter implements DataGetter{
	private Document document;
	/**以运行为单位的参数，是holmosparameter的子集*/
	private static final String parameter="parameter";
	private static final String id="id";
	private static final String element="element";
	public XMLDataGetter(String XMLFilePath){
		this.document=HolmosXMLUtils.getDocument(XMLFilePath);
	}
	@Override
	public ArrayList<Object[]> getParameterByIDs(int[] ids) {
		ArrayList<Object[]> result=new ArrayList<Object[]>();
		for(int id:ids)
			result.addAll(getParameterByID(id));
		return result;
	}

	@Override
	public ArrayList<Object[]> getAllParameter() {
		ArrayList<Object[]> result=new ArrayList<Object[]>();
		for(Element parameter:getAllParameterNodes()){
			result.add(getParameterInfo(parameter));
		}
		return result;
	}
	@Override
	public ArrayList<Object[]> getParameterByID(int id) {
		ArrayList<Object[]> result=new ArrayList<Object[]>();
		for(Object[] parameter:getAllParameter()){
			if((Integer)parameter[0] ==id){
				result.add(getActualParameter(parameter));
			}
		}
		return result;
	}
	/**
	 * 获取此xml文件的所有的testcase节点
	 * */
	private ArrayList<Element>getAllParameterNodes(){
		ArrayList<Element> parameters=new ArrayList<Element>();
		Element root=document.getRootElement();
		for(@SuppressWarnings("unchecked")
		Iterator<Element>it=root.elementIterator();it.hasNext();){
			Element node=it.next();
			if(node.getName().equalsIgnoreCase(parameter))
				parameters.add(node);
		}return parameters;
	}
	
	
	/**
	 * 获取以case为单位的参数组信息
	 * @param holmosParameterNode <testcase></testcase>节点中参数信息
	 * */
	private Object[] getParameterInfo(Element parameterNode){
		int id=hasIDAttribute(parameterNode);
		if(ConstValue.ERROR==id)return null;
		ArrayList<Object>result=new ArrayList<Object>();
		result.add(id);
		for(@SuppressWarnings("unchecked")
		Iterator<Element>it=parameterNode.elementIterator();it.hasNext();){
			Element node=it.next();
			if(node.getName().equalsIgnoreCase(element)){
				result.add(node.getStringValue());
			}
		}return result.toArray();
	}
	/**
	 * 查看parameter 节点是否有id属性，id属性标志了参数存储文件和注解中的id的对应情况,如果有id，返回id值，如果没有，则返回-1
	 * */
	private int hasIDAttribute(Element testcaseParameterNode){
		for(@SuppressWarnings("unchecked")
		Iterator<Attribute>it=testcaseParameterNode.attributeIterator();it.hasNext();){
			Attribute attribute=it.next();
			if(attribute.getName()==id){
				return Integer.parseInt(attribute.getText().trim());
			}
		}return ConstValue.ERROR;
	}
	
	private Object[]getActualParameter(Object[]parameter){
		Object[] acutalParameter=new Object[parameter.length-1];
		for(int i=1;i<parameter.length;i++)
			acutalParameter[i-1]=parameter[i];
		return acutalParameter;
	}
}
